let tableIngresos;
let rowTable = "";
let divLoading = document.querySelector("#divLoading");

var minDate, maxDate;
 
// Custom filtering function which will search data in column four between two values
$.fn.dataTable.ext.search.push(
 function( settings, data, dataIndex ) {
     var min = minDate.val();
     var max = maxDate.val();
     var date = new Date( data[1] );

     if (
         ( min === null && max === null ) ||
         ( min === null && date <= max ) ||
         ( min <= date   && max === null ) ||
         ( min <= date   && date <= max )
     ) {
         return true;
     }
     return false;
 }
);

document.addEventListener('DOMContentLoaded', function(){

// Create date inputs
minDate = new DateTime($('#min'), {
    format: 'D/M/YYYY'
});
maxDate = new DateTime($('#max'), {
    format: 'D/M/YYYY'
});

   var tableIngresos = $('#tableIngresos').DataTable( {

    footerCallback: function (row, data, start, end, display) {
        var api = this.api();

        // Remove the formatting to get integer data for summation
        var intVal = function (i) {
            return typeof i === 'string' ? i.replace(/[\$,]/g, '') * 1 : typeof i === 'number' ? i : 0;
        };            

        // Total over all pages
        importe = api
            .column(10,{ page: 'current' })
            .data()
            .reduce(function (a, b) {
                return intVal(a) + intVal(b);
            }, 0); 
            
        saldo = api
            .column(9,{ page: 'current' })
            .data()
            .reduce(function (a, b) {
                return intVal(a) + intVal(b);
            }, 0);

        

        // Update footer
        //$(api.column(12).footer()).html('S/.' + pageTotal + '   de( S/.' + total + ' Total)');
        //$(api.column(7).footer()).html('' + Math.round((pageTotal + Number.EPSILON)*100 )/100);
       
        $(api.column(9).footer()).html('' + Math.round((saldo + Number.EPSILON)*100 )/100);    
        $(api.column(10).footer()).html('' + Math.round((importe + Number.EPSILON)*100 )/100);
       

       // $(api.column(13).footer()).html('' + (Math.round((totale + Number.EPSILON)*100 )/100) - (Math.round((totals + Number.EPSILON)*100 )/100));

       // $(api.column(16).footer()).html('' + (Math.round((totalcte + Number.EPSILON)*100 )/100) - (Math.round((totalcts + Number.EPSILON)*100 )/100));

       // $(api.column(14).footer()).html('' + Math.round((totalcuf + Number.EPSILON)*100 )/100);
       // $(api.column(15).footer()).html('' + Math.round((totalctf + Number.EPSILON)*100 )/100);
    },
        "aProcessing":true,
        "aServerSide":true,
        "language": {
            "url": "//cdn.datatables.net/plug-ins/1.10.20/i18n/Spanish.json"
        },
        "ajax":{
            "url": " "+base_url+"/Ingresos/getIngresos",
            "dataSrc":""
        },
        "columns":[
            
            {"data":"idingresosc"},
                     
            {"data":"fecha"}, 
            {"data":"nrodo"}, 
            {"data":"documento"},
            {"data":"dni"},  
            {"data":"cliente"}, 
            {"data":"fecha_entrega"}, 
            {"data":"total"}, 
            {"data":"acuenta"}, 
            {"data":"saldo"}, 
            {"data":"importe"},                        
            {"data":"status"},
            {"data":"entrega"},
            {"data":"nomape"},
            {"data":"options"}
        ],
        searchPanes: {
            layout: 'columns-3',
            //cascadePanes: true
            initCollapsed: true,
        },
        "columnDefs": [
                     {
                       // "targets": [0,3,4,6],
                        //"visible": false
                       // "searchable": false text-right text-left
                    },

                    { 'className': "textcenter", "targets": [ 0 ] },
                    { 'className': "textcenter", "targets": [ 1 ] },
                    { 'className': "textcenter", "targets": [ 2 ] },
                    { 'className': "textcenter", "targets": [ 3 ] },
                    { 'className': "textcenter", "targets": [ 4 ] },
                    { 'className': "textcenter", "targets": [ 5 ] },
                    { 'className': "textcenter", "targets": [ 6 ] },
                    { 'className': "text-right", "targets": [ 7 ] },
                    { 'className': "text-right", "targets": [ 8 ] },
                    { 'className': "text-right", "targets": [ 9 ] },
                    { 'className': "text-right", "targets": [ 10 ] },
                    { 'className': "textcenter", "targets": [ 11 ] },
                    { 'className': "textcenter", "targets": [ 12 ] },
                    { 'className': "textcenter", "targets": [ 13 ] },
                    
                    {
                        searchPanes: {
                            show: false
                        },
                        
                    },
                  ], 
        'dom': 'Blfrtip',
        'buttons': [
            {
                "extend": "excelHtml5",
                "text": "<i class='fas fa-file-excel'></i> Excel",
                "titleAttr":"Esportar a Excel",
                "className": "btn btn-success",
                "footer": "true",
                "exportOptions": { 
                    "columns": [0,1,2,3,4,5,6,7,8,9,10] 
                }
            },{
                "extend": "pdfHtml5",
                "text": "<i class='fas fa-file-pdf'></i> PDF",
                "titleAttr":"Esportar a PDF",
                "className": "btn btn-danger",
                "orientation": "landscape", 
                "footer": "true",
                "pageSize": "A4",
                "exportOptions": { 
                    "columns": [0,1,2,3,4,5,6,7,8,9,10] 
                },
                customize: function (doc) {
                    
                    //ancho de columnas al 100%
                    doc.content[1].table.widths = Array(doc.content[1].table.body[0].length + 1).join('*').split('');
                    
                    //doc.content[1].table.widths = [ '4%', '29%', '16%', '17%', '6%', '5%', '5%', '8%', '11%'];
                    doc.content.splice(0,1);                    
                    var now = new Date();
                    var jsDate = now.getDate()+'-'+(now.getMonth()+1)+'-'+now.getFullYear();
                    doc.pageMargins = [20,40,20,30];
                    doc.defaultStyle.fontSize = 9.5;
                    doc.styles.tableHeader.fontSize = 9.5;
                    doc['header']=(function() {
                        return {
                            columns: [
                                {
                                    alignment: 'center',
                                    fontSize: 12,
                                    text: 'TOTAL DE INGRESOS'
                                }
                            ],
                            margin: 15
                        }
                    });
                    doc['footer']=(function(page, pages) {
                        return {
                            columns: [
                                {
                                    alignment: 'left',
                                    text: ['Creado el: ', { text: jsDate.toString() }]
                                },
                                {
                                    alignment: 'right',
                                    text: ['Página ', { text: page.toString() },	' de ',	{ text: pages.toString() }]
                                }
                            ],
                            margin: 5
                        }
                    });
                    var objLayout = {};
                    objLayout['hLineWidth'] = function(i) { return .5; };
                    objLayout['vLineWidth'] = function(i) { return .5; };
                    objLayout['hLineColor'] = function(i) { return '#aaa'; };
                    objLayout['vLineColor'] = function(i) { return '#aaa'; };
                    objLayout['paddingLeft'] = function(i) { return 4; };
                    objLayout['paddingRight'] = function(i) { return 4; };
                    doc.content[0].layout = objLayout;
            }
            },
        ],
        "resonsieve":"true",
        "bDestroy": true,
        "iDisplayLength": 10,
        "order":[[0,"desc"]]  
        
    }); 
    
    // Refilter the table
    $('#min, #max').on('change', function () {
        tableIngresos.draw();
    });

    $('#max, #min').on('change', function () {
        tableIngresos.draw();
    })

    

    



    //NUEVO 
    let formIngresos = document.querySelector("#formIngresos");
    formIngresos.onsubmit = function(e) {
        e.preventDefault();
          
        let intStatus = document.querySelector('#listStatus').value;
        if(intStatus == '')
        {
            swal("Atención", "Todos los campos son obligatorios." , "error");
            return false;
        }
        divLoading.style.display = "flex";
        let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
        let ajaxUrl = base_url+'/Ingresos/setIngresos'; 
        let formData = new FormData(formIngresos);
        request.open("POST",ajaxUrl,true);
        request.send(formData);
        request.onreadystatechange = function(){
           if(request.readyState == 4 && request.status == 200){                
                let objData = JSON.parse(request.responseText);
                if(objData.status)
                {
                    if(rowTable == ""){
                         $('#tableIngresos').DataTable().ajax.reload();
                            fntViewImporte();
                            fntViewEgreso();
                            fntViewSaldo();
                            fntViewCanel();
                    }else{
                         $('#tableIngresos').DataTable().ajax.reload();
                            fntViewImporte();
                            fntViewEgreso();
                            fntViewSaldo();
                            fntViewCanel();
                    }
                    $('#modalFormIngresos').modal("hide");
                    formIngresos.reset();
                    swal("Ingresos", objData.msg ,"success");                   
                }else{
                    swal("Error", objData.msg , "error");
                }              
            } 
            divLoading.style.display = "none";
            return false;
        }
    };

     //NUEVO 
     let formIngresos2 = document.querySelector("#formIngresos2");
     formIngresos2.onsubmit = function(e) {
         e.preventDefault();
           
         let intStatus = document.querySelector('#listStatus2').value;
         if(intStatus == '')
         {
             swal("Atención", "Todos los campos son obligatorios." , "error");
             return false;
         }
         divLoading.style.display = "flex";
         let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
         let ajaxUrl = base_url+'/Ingresos/setIngresos2'; 
         let formData = new FormData(formIngresos2);
         request.open("POST",ajaxUrl,true);
         request.send(formData);
         request.onreadystatechange = function(){
            if(request.readyState == 4 && request.status == 200){                
                 let objData = JSON.parse(request.responseText);
                 if(objData.status)
                 {
                     if(rowTable == ""){
                          $('#tableIngresos').DataTable().ajax.reload();
                     }else{
                          $('#tableIngresos').DataTable().ajax.reload();
                     }
                     $('#modalFormIngresos2').modal("hide");
                     formIngresos2.reset();
                     swal("Ingresos", objData.msg ,"success");                   
                 }else{
                     swal("Error", objData.msg , "error");
                 }              
             } 
             divLoading.style.display = "none";
             return false;
         }
     }



    fntClientes();
    fntViewImporte();
    fntViewEgreso();
    fntViewSaldo();
    fntViewCanel();

}, false);

function borrarF(){  
    location.reload();
}

function fntViewImporte(){
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Ingresos/getImp/';
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#totimp").innerHTML = 'TOTAL DE INGRESOS S/. '+ objData.data.imptotal;
               // alert(objData.data.imptotal)              
              
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}

function fntViewCanel(){
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Ingresos/getCancel/';
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#cancelar").innerHTML = 'DEUDAS POR COBRAR&nbsp;&nbsp;&nbsp; S/. '+ objData.data.pendiente;
               // alert(objData.data.imptotal)              
              
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}

function fntViewSaldo(){
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Egresos/getSald/';
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#totsaldo").innerHTML = 'SALDO DISPONIBLE&nbsp;&nbsp;&nbsp; S/. '+ objData.data.saldo;
               // alert(objData.data.imptotal)              
              
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}

function fntViewEgreso(){
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Egresos/getEgres/';
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#totegres").innerHTML = 'TOTAL DE EGRESOS&nbsp;&nbsp;&nbsp; S/. '+ objData.data.imptotal;
               // alert(objData.data.imptotal)              
              
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}
//VISUALIZAR INFORMACION
function fntViewInfo(idproducto){
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Productos/getPro/'+idproducto;
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#celProducto").innerHTML = objData.data.descripcion;

                switch(objData.data.categoria) {
                    case '1':
                        document.querySelector("#celCategoria").innerHTML = '<span">BEBIDAS</span>';  
                    break;
                    case '2':
                        document.querySelector("#celCategoria").innerHTML = '<span">LACTEOS</span>';  
                    break;
                    case '3':
                        document.querySelector("#celCategoria").innerHTML = '<span">CEREALES</span>';  
                    break;
                    case '4':
                        document.querySelector("#celCategoria").innerHTML = '<span">GRANOS</span>';  
                    break;
                    case '5':
                        document.querySelector("#celCategoria").innerHTML = '<span">CONSERVAS</span>';  
                    break;                 

                default:
                    document.querySelector("#celCategoria").innerHTML = '<span">Categoria incorrecta</span>';  
              }

                
                let estado = objData.data.status == 1 ? 
                '<span class="badge badge-success">Activo</span>' : 
                '<span class="badge badge-danger">Inactivo</span>';
                document.querySelector("#celEstado").innerHTML = estado;
                $('#modalViewProductos').modal('show');
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}


//EDITAR SECTOR
function fntEditInfo(element,idingreso){
    rowTable = element.parentNode.parentNode.parentNode;
    document.querySelector('#titleModal').innerHTML ="Modificar Ingreso";
    document.querySelector('.modal-header').classList.replace("headerRegister", "headerUpdate");
    document.querySelector('#btnActionForm').classList.replace("btn-primary", "btn-info");
    document.querySelector('#btnText').innerHTML ="Actualizar";
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Ingresos/getIngr/'+idingreso;
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#idIngresos").value = objData.data.idingresos;

                document.querySelector("#txtDocumento").value = objData.data.documento;
                document.querySelector("#txtFecha").value = objData.data.fecha;
                document.querySelector("#nroDoc").value = objData.data.nrodoc;
                document.querySelector("#listDni").value = objData.data.id_cliente; 
                $('#listDni').selectpicker('render'); 

                document.querySelector("#txtCantidad1").value = objData.data.cantidad1;  
                document.querySelector("#txtDescripcion1").value = objData.data.descripcion1;
                document.querySelector("#txtPrecio1").value = objData.data.precio1;  
                document.querySelector("#txtImporte1").value = objData.data.importe1;
                document.querySelector("#txtCantidad2").value = objData.data.cantidad2;  
                document.querySelector("#txtDescripcion2").value = objData.data.descripcion2;
                document.querySelector("#txtPrecio2").value = objData.data.precio2;  
                document.querySelector("#txtImporte2").value = objData.data.importe2;
                document.querySelector("#txtCantidad3").value = objData.data.cantidad3;  
                document.querySelector("#txtDescripcion3").value = objData.data.descripcion3;
                document.querySelector("#txtPrecio3").value = objData.data.precio3;  
                document.querySelector("#txtImporte3").value = objData.data.importe3;
                document.querySelector("#txtCantidad4").value = objData.data.cantidad4;  
                document.querySelector("#txtDescripcion4").value = objData.data.descripcion4;
                document.querySelector("#txtPrecio4").value = objData.data.precio4;  
                document.querySelector("#txtImporte4").value = objData.data.importe4;
                document.querySelector("#txtCantidad5").value = objData.data.cantidad5;  
                document.querySelector("#txtDescripcion5").value = objData.data.descripcion5;
                document.querySelector("#txtPrecio5").value = objData.data.precio5;  
                document.querySelector("#txtImporte5").value = objData.data.importe5;
                document.querySelector("#txtCantidad6").value = objData.data.cantidad6;  
                document.querySelector("#txtDescripcion6").value = objData.data.descripcion6;
                document.querySelector("#txtPrecio6").value = objData.data.precio6;  
                document.querySelector("#txtImporte6").value = objData.data.importe6;
                document.querySelector("#txtCantidad7").value = objData.data.cantidad7;  
                document.querySelector("#txtDescripcion7").value = objData.data.descripcion7;
                document.querySelector("#txtPrecio7").value = objData.data.precio7;  
                document.querySelector("#txtImporte7").value = objData.data.importe7;
                document.querySelector("#txtCantidad8").value = objData.data.cantidad8;  
                document.querySelector("#txtDescripcion8").value = objData.data.descripcion8;
                document.querySelector("#txtPrecio8").value = objData.data.precio8;  
                document.querySelector("#txtImporte8").value = objData.data.importe8;
                document.querySelector("#txtCantidad9").value = objData.data.cantidad9;  
                document.querySelector("#txtDescripcion9").value = objData.data.descripcion9;
                document.querySelector("#txtPrecio9").value = objData.data.precio9;  
                document.querySelector("#txtImporte9").value = objData.data.importe9;
                document.querySelector("#txtCantidad10").value = objData.data.cantidad10;  
                document.querySelector("#txtDescripcion10").value = objData.data.descripcion10;
                document.querySelector("#txtPrecio10").value = objData.data.precio10;  
                document.querySelector("#txtImporte10").value = objData.data.importe10;

                document.querySelector("#txtFechae").value = objData.data.fecha_entrega;
                document.querySelector("#txtSubtotal").value = objData.data.subtotal;

                var checkIgv = document.getElementById('chkIgv');
                if(objData.data.igv > 0) {
                    checkIgv.checked = true;
                } else {
                    checkIgv.checked = false;
                };

                document.querySelector("#txtIgv").value = objData.data.igv;
                document.querySelector("#txtTotal").value = objData.data.total;

                if (objData.data.acuenta > 0 && objData.data.saldo > 0 ) {
                    document.getElementById('txtAcuenta').readOnly = false;
                    document.getElementById('txtSaldo').readOnly = true;
                }else{
                    document.getElementById('txtAcuenta').readOnly = true;
                    document.getElementById('txtSaldo').readOnly = true;
                };

                document.querySelector("#txtAcuenta").value = objData.data.acuenta;
                document.querySelector("#txtSaldo").value = objData.data.saldo;
               // document.querySelector("#txtImporte").value = objData.data.importe;

                document.querySelector("#listStatus").value = objData.data.status; 
                $('#listStatus').selectpicker('render');               
                
                
                $('#modalFormIngresos').modal('show');

            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}

function fntEditInfo2(element,idingreso){
    rowTable = element.parentNode.parentNode.parentNode;
    document.querySelector('#titleModal').innerHTML ="Modificar estado de entrega";
    document.querySelector('.modal-header').classList.replace("headerRegister", "headerUpdate");
    document.querySelector('#btnActionForm').classList.replace("btn-primary", "btn-info");
    document.querySelector('#btnText').innerHTML ="Actualizar";
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Ingresos/getIngr/'+idingreso;
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#idIngresos2").value = objData.data.idingresos;
                document.querySelector("#nroDoc2").value = objData.data.nrodoc;                

                document.querySelector("#listStatus2").value = objData.data.entrega; 
                $('#listStatus2').selectpicker('render');               
                //alert(objData.data.status)
                $('#modalFormIngresos2').modal('show');

            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}


function busProd(idprod){
   //alert(idprod);
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Inventario/getInvent/'+idprod;
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
 
            if(objData.status)
            {
             document.querySelector("#txtCt").value = objData.data.cf;
             document.querySelector("#txtCut").value = objData.data.cuf;
             document.querySelector("#txtCtt").value = objData.data.ctf;
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
 }



    function imp01(){ 
        let importe01 = Math.abs(document.querySelector("#txtCantidad1").value) * Math.abs(document.querySelector("#txtPrecio1").value);    
        document.querySelector("#txtImporte1").value = Math.round((importe01 + Number.EPSILON)*100 )/100; 
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);        
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100;

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp02(){  
        let importe02 = Math.abs(document.querySelector("#txtCantidad2").value) * Math.abs(document.querySelector("#txtPrecio2").value);   
        document.querySelector("#txtImporte2").value = Math.round((importe02 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp03(){ 
        let importe03 = Math.abs(document.querySelector("#txtCantidad3").value) * Math.abs(document.querySelector("#txtPrecio3").value);     
        document.querySelector("#txtImporte3").value = Math.round((importe03 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp04(){ 
        let importe04 = Math.abs(document.querySelector("#txtCantidad4").value) * Math.abs(document.querySelector("#txtPrecio4").value);   
        document.querySelector("#txtImporte4").value = Math.round((importe04 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
        if(checkIgv.checked == true) {
            let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
            let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
            document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
            document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
            document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
            document.querySelector("#txtSaldo").value = 0.00;
        } else {
            document.querySelector("#txtIgv").value = 0.00;
            let total =  Math.abs(document.querySelector("#txtSubtotal").value);
            document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
            document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
            document.querySelector("#txtSaldo").value = 0.00;
        };
    }
    function imp05(){   
        let importe05 = Math.abs(document.querySelector("#txtCantidad5").value) * Math.abs(document.querySelector("#txtPrecio5").value); 
        document.querySelector("#txtImporte5").value = Math.round((importe05 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp06(){  
        let importe06 = Math.abs(document.querySelector("#txtCantidad6").value) * Math.abs(document.querySelector("#txtPrecio6").value);  
        document.querySelector("#txtImporte6").value = Math.round((importe06 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp07(){  
        let importe07 = Math.abs(document.querySelector("#txtCantidad7").value) * Math.abs(document.querySelector("#txtPrecio7").value);  
        document.querySelector("#txtImporte7").value = Math.round((importe07 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp08(){  
        let importe08 = Math.abs(document.querySelector("#txtCantidad8").value) * Math.abs(document.querySelector("#txtPrecio8").value);   
        document.querySelector("#txtImporte8").value = Math.round((importe08 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp09(){ 
        let importe09 = Math.abs(document.querySelector("#txtCantidad9").value) * Math.abs(document.querySelector("#txtPrecio9").value);   
        document.querySelector("#txtImporte9").value = Math.round((importe09 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100;  

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }
    function imp10(){     
        let importe10 = Math.abs(document.querySelector("#txtCantidad10").value) * Math.abs(document.querySelector("#txtPrecio10").value); 
        document.querySelector("#txtImporte10").value = Math.round((importe10 + Number.EPSILON)*100 )/100;
        let subtotal = Math.abs(document.querySelector("#txtImporte1").value) + Math.abs(document.querySelector("#txtImporte2").value) + Math.abs(document.querySelector("#txtImporte3").value) +
                    Math.abs(document.querySelector("#txtImporte4").value) + Math.abs(document.querySelector("#txtImporte5").value) + Math.abs(document.querySelector("#txtImporte6").value) +
                    Math.abs(document.querySelector("#txtImporte7").value) + Math.abs(document.querySelector("#txtImporte8").value) + Math.abs(document.querySelector("#txtImporte9").value) +
                    Math.abs( document.querySelector("#txtImporte10").value);
        document.querySelector("#txtSubtotal").value = Math.round((subtotal + Number.EPSILON)*100 )/100; 

        var checkIgv = document.getElementById('chkIgv');
            if(checkIgv.checked == true) {
                let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
                document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            } else {
                document.querySelector("#txtIgv").value = 0.00;
                let total =  Math.abs(document.querySelector("#txtSubtotal").value);
                document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
                document.querySelector("#txtSaldo").value = 0.00;
            };
    }

    function acta(){     
        
        let total =  Math.abs(document.querySelector("#txtTotal").value) - Math.abs(document.querySelector("#txtAcuenta").value);
        document.querySelector("#txtSaldo").value = Math.round((total + Number.EPSILON)*100 )/100;
    }

   

//LISTA USUARIOS
  function fntClientes(){

    if(document.querySelector('#listDni')){
        let ajaxUrl = base_url+'/Clientes/getSelectClientes';
        let request = (window.XMLHttpRequest) ? 
                    new XMLHttpRequest() : 
                    new ActiveXObject('Microsoft.XMLHTTP');
        request.open("GET",ajaxUrl,true);
        request.send();
        request.onreadystatechange = function(){
            if(request.readyState == 4 && request.status == 200){
                document.querySelector('#listDni').innerHTML = request.responseText;
                $('#listDni').val('0');
                $('#listDni').selectpicker('render');


            }
        }
    }
}



//ELIMINAR SECTOR

function fntDelInfo(idIngreso,nroDoc){
    //alert(idIngreso+nroDoc);
    swal({
        title: "Eliminar el ingreso",
        text: "¿Realmente quiere eliminar el ingreso?",
        type: "warning",
        showCancelButton: true,
        confirmButtonText: "Si, eliminar!",
        cancelButtonText: "No, cancelar!",
        closeOnConfirm: false,
        closeOnCancel: true
    }, function(isConfirm) {
        
        if (isConfirm) 
        {
            let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
            let ajaxUrl = base_url+'/Ingresos/delIngreso';
            let strData = "idIngreso="+idIngreso+"&nroDoc="+nroDoc;
            request.open("POST",ajaxUrl,true);
            request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            request.send(strData);
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    let objData = JSON.parse(request.responseText);
                    if(objData.status)
                    {
                        swal("Eliminar!", objData.msg , "success");
                         $('#tableIngresos').DataTable().ajax.reload();
                         fntViewImporte();
                            fntViewEgreso();
                            fntViewSaldo();
                            fntViewCanel();
                    }else{
                        swal("Atención!", objData.msg , "error");
                        fntViewImporte();
                            fntViewEgreso();
                            fntViewSaldo();
                            fntViewCanel();
                    }
                }
            }
        }

    });

}

    var checkIgv = document.getElementById('chkIgv');   
     checkIgv.addEventListener('click', function() {
       if(checkIgv.checked) {
        let igv =  Math.abs(document.querySelector("#txtSubtotal").value) * 0.18;
        let total =  Math.abs(document.querySelector("#txtSubtotal").value) + igv;
        document.querySelector("#txtIgv").value = Math.round((igv + Number.EPSILON)*100 )/100;
        document.querySelector("#txtTotal").value = Math.round((total + Number.EPSILON)*100 )/100;
        document.querySelector("#txtAcuenta").value = Math.round((total + Number.EPSILON)*100 )/100;
        document.querySelector("#txtSaldo").value = 0.00;
       } else {
        document.querySelector("#txtIgv").value = 0.00;
        document.querySelector("#txtTotal").value = Math.abs(document.querySelector("#txtSubtotal").value);
        document.querySelector("#txtAcuenta").value = Math.abs(document.querySelector("#txtSubtotal").value);
        document.querySelector("#txtSaldo").value = 0.00;
       }
     });

     

    function status() {
        var miCheckbox = document.getElementById('listStatus');
        if(miCheckbox.value == 1) {
            let acuenta =  Math.abs(document.querySelector("#txtTotal").value);
            document.querySelector("#txtAcuenta").value = Math.round((acuenta + Number.EPSILON)*100 )/100;
            document.querySelector("#txtSaldo").value = 0.00;
            document.getElementById('txtAcuenta').readOnly = true;
            document.getElementById('txtSaldo').readOnly = true;
        } else {
            let acuenta =  Math.abs(document.querySelector("#txtTotal").value) ;
            document.querySelector("#txtAcuenta").value = 0.00;
            document.querySelector("#txtSaldo").value = Math.round((acuenta + Number.EPSILON)*100 )/100;
            document.getElementById('txtAcuenta').readOnly = false;
            document.getElementById('txtSaldo').readOnly = true;
        }
    };

 

    function fntCancelar(idIngresos){
        swal({
            title: "Cancelar deuda",
            text: "¿Realmente quiere cancelar la deuda?",
            type: "warning",
            showCancelButton: true,
            confirmButtonText: "Si, Generar!",
            cancelButtonText: "No, cancelar!",
            closeOnConfirm: false,
            closeOnCancel: true
        }, function(isConfirm) {
            
            if (isConfirm) 
            {
                let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
                let ajaxUrl = base_url+'/Ingresos/opCancelar';
                let strData = "idIngresos="+idIngresos;
                request.open("POST",ajaxUrl,true);
                request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
                request.send(strData);
                request.onreadystatechange = function(){
                    if(request.readyState == 4 && request.status == 200){
                        let objData = JSON.parse(request.responseText);
                        if(objData.status)
                        {
                            swal("Generar!", objData.msg , "success");
                             $('#tableIngresos').DataTable().ajax.reload();
                             fntViewImporte();
                            fntViewEgreso();
                            fntViewSaldo();
                            fntViewCanel();
                        }else{
                            swal("Atención!", objData.msg , "error");
                            fntViewImporte();
                            fntViewEgreso();
                            fntViewSaldo();
                            fntViewCanel();
                        }
                    }
                }
            }
    
        });
    
    }

function openModal()
{
    rowTable = "";
    document.querySelector('#idIngresos').value ="";
    document.querySelector('.modal-header').classList.replace("headerUpdate", "headerRegister");
    document.querySelector('#btnActionForm').classList.replace("btn-info", "btn-primary");
    document.querySelector('#btnText').innerHTML ="Guardar";
    document.querySelector('#titleModal').innerHTML = "Nuevo ";
    
    document.getElementById('txtAcuenta').readOnly = true;
    document.getElementById('txtSaldo').readOnly = true;
   
    $('#listDni').val('1');
    $('#listDni').selectpicker('render');

    $('#listStatus').val('1');
    $('#listStatus').selectpicker('render');

    document.querySelector("#formIngresos").reset();
    $('#modalFormIngresos').modal('show');
}