let tableProductos;
let rowTable = "";
let divLoading = document.querySelector("#divLoading");
document.addEventListener('DOMContentLoaded', function(){

    tableProductos = $('#tableProductos').dataTable( {
        "aProcessing":true,
        "aServerSide":true,
        "language": {
            "url": "//cdn.datatables.net/plug-ins/1.10.20/i18n/Spanish.json"
        },
        "ajax":{
            "url": " "+base_url+"/Productos/getProductos",
            "dataSrc":""
        },
        "columns":[
            
            {"data":"idproducto"},        
            {"data":"descripcion"}, 
            {"data":"categoria"}, 
                        
            {"data":"status"},
            {"data":"options"}
        ],
        searchPanes: {
            layout: 'columns-3',
            //cascadePanes: true
            initCollapsed: true,
        },
        "columnDefs": [
                     {
                       // "targets": [0,3,4,6],
                        //"visible": false
                       // "searchable": false
                    },

                    { 'className': "textcenter", "targets": [ 0 ] },
                    { 'className': "textcenter", "targets": [ 1 ] },
                    { 'className': "textcenter", "targets": [ 2 ] },
                    { 'className': "textcenter", "targets": [ 3 ] },
                    { 'className': "textcenter", "targets": [ 4 ] },
                    
                    {
                        searchPanes: {
                            show: false
                        },
                        
                    },
                  ], 
        'dom': 'Blfrtip',
        'buttons': [
            {
                "extend": "excelHtml5",
                "text": "<i class='fas fa-file-excel'></i> Excel",
                "titleAttr":"Esportar a Excel",
                "className": "btn btn-success",
                "exportOptions": { 
                    "columns": [0,1,2,3,4,5] 
                }
            },{
                "extend": "pdfHtml5",
                "text": "<i class='fas fa-file-pdf'></i> PDF",
                "titleAttr":"Esportar a PDF",
                "className": "btn btn-danger",
                "exportOptions": { 
                    "columns": [0,1,2,3,4,5] 
                }
            },
        ],
        "resonsieve":"true",
        "bDestroy": true,
        "iDisplayLength": 10,
        "order":[[0,"desc"]]  
    });



    //NUEVO 
    let formProductos = document.querySelector("#formProductos");
    formProductos.onsubmit = function(e) {
        e.preventDefault();
          
        let intStatus = document.querySelector('#listStatus').value;
        if(intStatus == '')
        {
            swal("Atención", "Todos los campos son obligatorios." , "error");
            return false;
        }
        divLoading.style.display = "flex";
        let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
        let ajaxUrl = base_url+'/Productos/setProductos'; 
        let formData = new FormData(formProductos);
        request.open("POST",ajaxUrl,true);
        request.send(formData);
        request.onreadystatechange = function(){
           if(request.readyState == 4 && request.status == 200){                
                let objData = JSON.parse(request.responseText);
                if(objData.status)
                {
                    if(rowTable == ""){
                        tableProductos.api().ajax.reload();
                    }else{
                        tableProductos.api().ajax.reload();
                    }
                    $('#modalFormProductos').modal("hide");
                    formProductos.reset();
                    swal("Productos", objData.msg ,"success");                   
                }else{
                    swal("Error", objData.msg , "error");
                }              
            } 
            divLoading.style.display = "none";
            return false;
        }
    }

}, false);


//VISUALIZAR INFORMACION
function fntViewInfo(idproducto){
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Productos/getPro/'+idproducto;
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#celProducto").innerHTML = objData.data.descripcion;

                switch(objData.data.categoria) {
                    case '1':
                        document.querySelector("#celCategoria").innerHTML = '<span">BEBIDAS</span>';  
                    break;
                    case '2':
                        document.querySelector("#celCategoria").innerHTML = '<span">LACTEOS</span>';  
                    break;
                    case '3':
                        document.querySelector("#celCategoria").innerHTML = '<span">CEREALES</span>';  
                    break;
                    case '4':
                        document.querySelector("#celCategoria").innerHTML = '<span">GRANOS</span>';  
                    break;
                    case '5':
                        document.querySelector("#celCategoria").innerHTML = '<span">CONSERVAS</span>';  
                    break;                 

                default:
                    document.querySelector("#celCategoria").innerHTML = '<span">Categoria incorrecta</span>';  
              }

                
                let estado = objData.data.status == 1 ? 
                '<span class="badge badge-success">Activo</span>' : 
                '<span class="badge badge-danger">Inactivo</span>';
                document.querySelector("#celEstado").innerHTML = estado;
                $('#modalViewProductos').modal('show');
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}


//EDITAR SECTOR
function fntEditInfo(element,idproducto){
    rowTable = element.parentNode.parentNode.parentNode;
    document.querySelector('#titleModal').innerHTML ="Modificar Producto";
    document.querySelector('.modal-header').classList.replace("headerRegister", "headerUpdate");
    document.querySelector('#btnActionForm').classList.replace("btn-primary", "btn-info");
    document.querySelector('#btnText').innerHTML ="Actualizar";
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Productos/getPro/'+idproducto;
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
            if(objData.status)
            {
                document.querySelector("#idProductos").value = objData.data.idproducto;
                document.querySelector("#txtProducto").value = objData.data.descripcion;

                document.querySelector("#listCategoria").value = objData.data.categoria; 
                $('#listCategoria').selectpicker('render');   

                document.querySelector("#listStatus").value = objData.data.status; 
                $('#listStatus').selectpicker('render');               
           
                $('#modalFormProductos').modal('show');

            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
}


function busProd(idprod){
   //alert(idprod);
    let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
    let ajaxUrl = base_url+'/Inventario/getInvent/'+idprod;
    request.open("GET",ajaxUrl,true);
    request.send();
    request.onreadystatechange = function(){
        if(request.readyState == 4 && request.status == 200){
            let objData = JSON.parse(request.responseText);
 
            if(objData.status)
            {
             document.querySelector("#txtCt").value = objData.data.cf;
             document.querySelector("#txtCut").value = objData.data.cuf;
             document.querySelector("#txtCtt").value = objData.data.ctf;
            }else{
                swal("Error", objData.msg , "error");
            }
        }
    }
 }

 function ceProd(ceprod){
    //alert(ceprod);
    document.querySelector("#txtCf").value = Math.abs(document.querySelector("#txtCt").value) + Math.abs(ceprod);
    document.querySelector("#txtCte").value = Math.abs(document.querySelector("#txtCue").value) * Math.abs(ceprod);
    document.querySelector("#txtCtf").value = Math.abs(document.querySelector("#txtCtt").value) + (Math.abs(document.querySelector("#txtCue").value) * Math.abs(ceprod));
    
    let cu = Math.abs(document.querySelector("#txtCtf").value) / Math.abs(document.querySelector("#txtCf").value);
    document.querySelector("#txtCuf").value = Math.round((cu + Number.EPSILON)*100 )/100 ;
  }


  function cteProd(cteprod){
   // alert(cteprod);
    document.querySelector("#txtCf").value = Math.abs(document.querySelector("#txtCt").value) +  Math.abs(document.querySelector("#txtCe").value);
    document.querySelector("#txtCte").value = Math.abs(document.querySelector("#txtCe").value) * Math.abs(cteprod);
    document.querySelector("#txtCtf").value = Math.abs(document.querySelector("#txtCtt").value) + Math.abs(document.querySelector("#txtCte").value);
    
    let cu = Math.abs(document.querySelector("#txtCtf").value) / Math.abs(document.querySelector("#txtCf").value);
    document.querySelector("#txtCuf").value = Math.round((cu + Number.EPSILON)*100 )/100 ;

  }

//ELIMINAR SECTOR

function fntDelInfo(idproducto){
    swal({
        title: "Eliminar el producto",
        text: "¿Realmente quiere eliminar el producto?",
        type: "warning",
        showCancelButton: true,
        confirmButtonText: "Si, eliminar!",
        cancelButtonText: "No, cancelar!",
        closeOnConfirm: false,
        closeOnCancel: true
    }, function(isConfirm) {
        
        if (isConfirm) 
        {
            let request = (window.XMLHttpRequest) ? new XMLHttpRequest() : new ActiveXObject('Microsoft.XMLHTTP');
            let ajaxUrl = base_url+'/Productos/delProducto';
            let strData = "idProducto="+idproducto;
            request.open("POST",ajaxUrl,true);
            request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
            request.send(strData);
            request.onreadystatechange = function(){
                if(request.readyState == 4 && request.status == 200){
                    let objData = JSON.parse(request.responseText);
                    if(objData.status)
                    {
                        swal("Eliminar!", objData.msg , "success");
                        tableProductos.api().ajax.reload();
                    }else{
                        swal("Atención!", objData.msg , "error");
                    }
                }
            }
        }

    });

}



function openModal()
{
    rowTable = "";
    document.querySelector('#idProductos').value ="";
    document.querySelector('.modal-header').classList.replace("headerUpdate", "headerRegister");
    document.querySelector('#btnActionForm').classList.replace("btn-info", "btn-primary");
    document.querySelector('#btnText').innerHTML ="Guardar";
    document.querySelector('#titleModal').innerHTML = "Nuevo ";


   

    $('#listStatus').val('1');
    $('#listStatus').selectpicker('render');

    document.querySelector("#formProductos").reset();
    $('#modalFormProductos').modal('show');
}