<?php
	class Productos extends Controllers{
		public function __construct()
		{
			parent::__construct();
			session_start();
			//session_regenerate_id(true);
			if(empty($_SESSION['login']))
			{
				header('Location: '.base_url().'/login');
				die();
			}
			getPermisos(17);//ojoooooooooo
		}

		public function Productos()
		{
			if(empty($_SESSION['permisosMod']['r'])){
				header("Location:".base_url().'/dashboard');
			}
			$data['page_tag'] = "Productos";
			$data['page_title'] = "Productos <small></small>";
			$data['page_name'] = "productos";
			$data['page_functions_js'] = "functions_productos.js";
			$this->views->getView($this,"productos",$data);
		}
		
		//NUEVO SECTOR
		public function setProductos(){
			if($_POST){
				if(empty($_POST['listStatus']) )
				{
					$arrResponse = array("status" => false, "msg" => 'Datos incorrectos.');
				}else{

					$intIdproductos = intval($_POST['idProductos']);				
					$strProducto = strClean($_POST['txtProducto']);
					$intCategoria = intval($_POST['listCategoria']);
					
					$intStatus = intval($_POST['listStatus']);					
					$ruta = $_SESSION['idUser'];
					$request_productos = "";

					if($intIdproductos == 0)
					{
						//NUEVO
						if($_SESSION['permisosMod']['w']){
							$request_productos = $this->model->insertProductos($strProducto,
																			$intCategoria,
																			$ruta, 
																			$intStatus);
							$option = 1;
						}
					}else{
						//MODIFICAR
						if($_SESSION['permisosMod']['u']){
							
							$request_productos = $this->model->updateProductos($intIdproductos,  
																			$strProducto,
																			$intCategoria,
																			$ruta, 
																			$intStatus);
							$option = 2;
						}
					}

					if($request_productos > 0 )
					{
						if($option == 1)
						{
							$arrResponse = array('status' => true, 'msg' => 'Producto guardado correctamente.');
							
						}else{
							$arrResponse = array('status' => true, 'msg' => 'Producto actualizado correctamente.');
							
						}
					}else if($request_productos == 'exist'){
						$arrResponse = array('status' => false, 'msg' => '¡Atención! el producto ya se registro.');
					}else{
						$arrResponse = array("status" => false, "msg" => 'No es posible almacenar los datos.');
					}
				}
				echo json_encode($arrResponse,JSON_UNESCAPED_UNICODE);
			}
			die();
		}

		//LISTAR CATEGORIAS EN LA TABLA PRINCIPAL
		public function getProductos()
		{
			if($_SESSION['permisosMod']['r']){
				$arrData = $this->model->selectProductos();
				for ($i=0; $i < count($arrData); $i++) {
					$btnOpenL = '';
					$btnView = '';
					$btnEdit = '';
					$btnDelete = '';
					//MOSTRAR ESTADO

					if($arrData[$i]['status'] == 1)
					{
						$arrData[$i]['status'] = '<span class="badge badge-success">Activo</span>';
					}else{
						$arrData[$i]['status'] = '<span class="badge badge-danger">Inactivo</span>';
					}	

					//MUESTRA CATEGORIA EN LA TABLA					
					switch ($arrData[$i]['categoria']) {
						case 1:
							$arrData[$i]['categoria'] = 'BEBIDAS';
							break;
						case 2:
							$arrData[$i]['categoria'] = 'LACTEOS';
							break;
						case 3:
							$arrData[$i]['categoria'] = 'CEREALES';
							break;
						case 4:
							$arrData[$i]['categoria'] = 'GRANOS';
							break;
						case 5:
							$arrData[$i]['categoria'] = 'CONSERVAS';
							break;
				
					}

									
					//BOTONES DE ACCIONES
					if($_SESSION['permisosMod']['r']){
						$btnView = '<button class="btn btn-info btn-sm" onClick="fntViewInfo('.$arrData[$i]['idproducto'].')" title="Ver categoría"><i class="far fa-eye"></i></button>';
					}
					if($_SESSION['permisosMod']['u']){
						$btnEdit = '<button class="btn btn-primary  btn-sm" onClick="fntEditInfo(this,'.$arrData[$i]['idproducto'].')" title="Editar categoría"><i class="fas fa-pencil-alt"></i></button>';
					}					
					if($_SESSION['permisosMod']['d']){	
						$btnDelete = '<button class="btn btn-danger btn-sm" onClick="fntDelInfo('.$arrData[$i]['idproducto'].')" title="Eliminar categoría"><i class="far fa-trash-alt"></i></button>';
					}
					$arrData[$i]['options'] = '<div class="text-center">'.$btnView.' '.$btnEdit.' '.$btnDelete.'</div>';
				}				
				echo json_encode($arrData,JSON_UNESCAPED_UNICODE);			
			}
			die();
		}

		//MOSTRAR CATEGORIA COMBO
		public function getSelectProductos(){
			$htmlOptions = "";
			$arrData = $this->model->selectProductos();
			if(count($arrData) > 0 ){
				for ($i=0; $i < count($arrData); $i++) { 
					if($arrData[$i]['status'] == 1 ){
					$htmlOptions .= '<option value="'.$arrData[$i]['idproducto'].'">'.$arrData[$i]['descripcion'].'</option>';
					}
				}
			}
			echo $htmlOptions;
			die();	
		}


		//EXTRAER DATOS PARA MODIFICAR
		public function getPro($idprod)
		{
			if($_SESSION['permisosMod']['r']){
				$intProducto = intval($idprod);
				if($intProducto > 0)
				{
					$arrData = $this->model->selectProduc($intProducto);
					if(empty($arrData))
					{
						$arrResponse = array('status' => false, 'msg' => 'Datos no encontrados.');
					}else{
						$arrResponse = array('status' => true, 'data' => $arrData);
					}
					echo json_encode($arrResponse,JSON_UNESCAPED_UNICODE);
				}
			}
			die();
		}


		//ELIMINAR SECTOR

		public function delProducto()
		{
			if($_POST){
				if($_SESSION['permisosMod']['d']){
					$intIdproducto = intval($_POST['idProducto']);
					$requestDelete = $this->model->deleteProducto($intIdproducto);
					if($requestDelete == 'ok')
					{
						$arrResponse = array('status' => true, 'msg' => 'Se ha eliminado el producto');
					}else if($requestDelete == 'exist'){
						$arrResponse = array('status' => false, 'msg' => 'No es posible eliminar un producto con registros asociados.');
					}else{
						$arrResponse = array('status' => false, 'msg' => 'Error al eliminar el producto.');
					}
					echo json_encode($arrResponse,JSON_UNESCAPED_UNICODE);
				}
			}
			die();
		}
	


	}


 ?>